{
Created with Borland Delphi Version 5

Demo program to show how to communicate
with 2 different SMC controllers in a single application
by using wp2comm.dll to communicate with the first controller
and a copy of wp2comm.dll (named wp2comm2.dll)
to communicate with the second controller.

Use of Wp2comm.ini is not recommended, because wp2comm.dll
and the copy are using the same Wp2comm.ini.

Topics:
1. Initialize, open and close controller
2. Use of interface functions to execute wrapped venus-commands
3. Executing free defined venus-commands
4. Use of [Ctrl]+[B] to abort commands
	After initializing and opening the controller
	enter '100 100 0 rmove' in the edit field,
	set LinesExpected to 0, press Execute
	and then press [Ctrl]+[B] to abort the move
5. Demonstrating synchronous and asynchronous mode
}

unit UMain;

interface

uses
  Windows, Messages, SysUtils, Forms, Dialogs,
  StdCtrls, Classes, Controls, inifiles, Spin, ExtCtrls;

const
//Message used in asynchronous mode to notify UserWin
//that the controller replied to a venus-command.
//See function InitController(), parameters AsyncMsg and UserWin.
//Also used to signal a detected serial port BREAK
	WMU_ASYNCREPLYCOMPLETE1=WM_USER+101;
	WMU_ASYNCREPLYCOMPLETE2=WM_USER+102;

	WP2_CONTROLLER_DEFAULT=1;
	WP2_CONTROLLER_DELTA=2;
	WP2_CONTROLLER_ALPHA=4;
	WP2_CONTROLLER_TAURUS=8;
	WP2_CONTROLLER_PEGASUS=16;
	WP2_CONTROLLER_ORION=32;
	WP2_CONTROLLER_CORVUS=64;

{
functions for use with controller 1
}
	function	InitController1(CMode:DWORD;Axes:DWORD;ComPort:DWORD;Baudrate:DWORD;UserWin:HWND;AsyncMsg:UINT;Mode:DWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'InitController';
	function	OpenController1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'OpenController';
	function	ResetComm1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'ResetComm';
	function	CloseController1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'CloseController';
	function	ExecuteCommand1(Command:LPSTR;LinesExpected:DWORD;Reply:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'ExecuteCommand';
	function	GetReply1(pReply:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetReply';
	function	AbortCommand1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'AbortCommand';

	function	Calibrate1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'Calibrate';
	function	ClearParameterStack1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'ClearParameterStack';
	function	GetAcceleration1(Accel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetAcceleration';
	function	GetAxisMode1(A1,A2,A3,A4:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetAxisMode';
	function	GetError1(Error:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetError';
	function	GetJoystickVelocity1(JoyVel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetJoystickVelocity';
	function	GetLimits1(A1Min,A1Max,A2Min,A2Max,A3Min,A3Max,A4Min,A4Max:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetLimits';
	function	GetParamsOnStack1(Value:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetParamsOnStack';
	function	GetPos1(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetPos';
	function	GetPosAxis1(Axis:DWORD;Pos:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetPosAxis';
	function	GetStatus1(Status:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetStatus';
	function	GetVelocity1(Vel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'GetVelocity';
	function	Identify1(Id:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'Identify';
	function	JoystickDisable1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'JoystickDisable';
	function	JoystickEnable1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'JoystickEnable';
	function	MoveAbsolute1(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'MoveAbsolute';
	function	MoveAbsoluteAutoReply1(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'MoveAbsoluteAutoReply';
	function	MoveRelative1(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'MoveRelative';
	function	MoveRelativeAutoReply1(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'MoveRelativeAutoReply';
	function	RangeMeasure1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'RangeMeasure';
	function	SetAcceleration1(Accel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'SetAcceleration';
	function	SetAxisMode1(A1,A2,A3,A4:DWORD)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'SetAxisMode';
	function	SetJoystickVelocity1(JoyVel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'SetJoystickVelocity';
	function	SetOrigin1
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'SetOrigin';
	function	SetVelocity1(Vel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm.dll' name 'SetVelocity';

{
functions for use with controller 2
}
	function	InitController2(CMode:DWORD;Axes:DWORD;ComPort:DWORD;Baudrate:DWORD;UserWin:HWND;AsyncMsg:UINT;Mode:DWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'InitController';
	function	OpenController2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'OpenController';
	function	ResetComm2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'ResetComm';
	function	CloseController2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'CloseController';
	function	ExecuteCommand2(Command:LPSTR;LinesExpected:DWORD;Reply:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'ExecuteCommand';
	function	GetReply2(pReply:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetReply';
	function	AbortCommand2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'AbortCommand';

	function	Calibrate2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'Calibrate';
	function	ClearParameterStack2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'ClearParameterStack';
	function	GetAcceleration2(Accel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetAcceleration';
	function	GetAxisMode2(A1,A2,A3,A4:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetAxisMode';
	function	GetError2(Error:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetError';
	function	GetJoystickVelocity2(JoyVel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetJoystickVelocity';
	function	GetLimits2(A1Min,A1Max,A2Min,A2Max,A3Min,A3Max,A4Min,A4Max:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetLimits';
	function	GetParamsOnStack2(Value:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetParamsOnStack';
	function	GetPos2(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetPos';
	function	GetPosAxis2(Axis:DWORD;Pos:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetPosAxis';
	function	GetStatus2(Status:LPDWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetStatus';
	function	GetVelocity2(Vel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'GetVelocity';
	function	Identify2(Id:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'Identify';
	function	JoystickDisable2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'JoystickDisable';
	function	JoystickEnable2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'JoystickEnable';
	function	MoveAbsolute2(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'MoveAbsolute';
	function	MoveAbsoluteAutoReply2(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'MoveAbsoluteAutoReply';
	function	MoveRelative2(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'MoveRelative';
	function	MoveRelativeAutoReply2(A1,A2,A3,A4:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'MoveRelativeAutoReply';
	function	RangeMeasure2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'RangeMeasure';
	function	SetAcceleration2(Accel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'SetAcceleration';
	function	SetAxisMode2(A1,A2,A3,A4:DWORD)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'SetAxisMode';
	function	SetJoystickVelocity2(JoyVel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'SetJoystickVelocity';
	function	SetOrigin2
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'SetOrigin';
	function	SetVelocity2(Vel:LPSTR)
			:DWORD;stdcall;external 'Wp2Comm2.dll' name 'SetVelocity';

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    GroupBoxInit: TGroupBox;
    LabelPort: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBoxPort1: TComboBox;
    ComboBoxBaudrate1: TComboBox;
    SpinEditAxes1: TSpinEdit;
    ButtonInit1: TButton;
    ComboBoxController1: TComboBox;
    GroupBox1: TGroupBox;
    LabelLinesExpected: TLabel;
    EditCommand1: TEdit;
    SpinEditLinesToReply1: TSpinEdit;
    ButtonOpenController1: TButton;
    ButtonCloseController1: TButton;
    ButtonTest1: TButton;
    CheckBoxCalRm1: TCheckBox;
    Label1: TLabel;
    Memo1: TMemo;
    Panel2: TPanel;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ComboBoxPort2: TComboBox;
    ComboBoxBaudrate2: TComboBox;
    SpinEditAxes2: TSpinEdit;
    ButtonInit2: TButton;
    ComboBoxController2: TComboBox;
    GroupBox3: TGroupBox;
    Label10: TLabel;
    EditCommand2: TEdit;
    SpinEditLinesToReply2: TSpinEdit;
    ButtonOpenController2: TButton;
    ButtonCloseController2: TButton;
    ButtonTest2: TButton;
    CheckBoxCalRm2: TCheckBox;
    Memo2: TMemo;
    Panel3: TPanel;
    Panel4: TPanel;
    procedure ButtonInit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonOpenController1Click(Sender: TObject);
    procedure EditCommand1KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonCloseController1Click(Sender: TObject);
    procedure ButtonTest1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
	 Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure ComboBoxController1Change(Sender: TObject);
  private
    { Private-Deklarationen }
	nAxes1:Integer;
	nAxes2:Integer;
	nControllerMode1:Integer;
	nControllerMode2:Integer;
	procedure	DoExecuteCommand(nControllerId:Integer);
	procedure WMUAsyncReplyComplete1(var Msg:TMessage);message WMU_ASYNCREPLYCOMPLETE1;
	procedure WMUAsyncReplyComplete2(var Msg:TMessage);message WMU_ASYNCREPLYCOMPLETE2;
	function	DoTest1:Boolean;
	function	DoTest2:Boolean;
	procedure	SetupComboBoxBaudrate(nMode:Integer;CBBaudrate:TComboBox);
  public
    { Public-Deklarationen }
  end;

var
  FormMain: TFormMain;
	pReply:array[0..7]of PChar;
	dwValue:array[0..3]of DWORD;


implementation

{$R *.DFM}

procedure TFormMain.FormCreate(Sender: TObject);
var
	i:Integer;
	MyIniFile:TIniFile;
	strId:string;
begin
nControllerMode1:=WP2_CONTROLLER_DEFAULT;
nControllerMode2:=WP2_CONTROLLER_DEFAULT;
for i:=0 to 7 do
	pReply[i]:=StrAlloc(256);
ClientHeight:=Memo1.Top+Memo1.Height+Memo1.Left;
ClientWidth:=Panel1.Width+Panel2.Width;
ButtonOpenController1.Enabled:=False;
ButtonOpenController2.Enabled:=False;
ButtonCloseController1.Enabled:=False;
ButtonCloseController2.Enabled:=False;
ButtonTest1.Enabled:=False;
ButtonTest2.Enabled:=False;
EditCommand1.Enabled:=False;
EditCommand2.Enabled:=False;
ComboBoxPort1.ItemIndex:=1;
ComboBoxPort2.ItemIndex:=1;
MyIniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'Wp2comm.ini');
strId:=MyIniFile.ReadString('Startup','CMode1','Default');
if (strId='Delta')or(strId='Delta-PC') then
	begin
	nControllerMode1:=WP2_CONTROLLER_DELTA;
	ComboBoxController1.ItemIndex:=1;
	SpinEditAxes1.MaxValue:=4;
	SpinEditAxes1.Value:=4;
	end
else if strId='Alpha' then
	begin
	nControllerMode1:=WP2_CONTROLLER_ALPHA;
	ComboBoxController1.ItemIndex:=2;
	SpinEditAxes1.Value:=4;
	ButtonTest1.Visible:=False;
	CheckBoxCalRm1.Visible:=False;
	EditCommand1.Text:='1 nversion';
	end
else if strId='Taurus' then
	begin
	nControllerMode1:=WP2_CONTROLLER_TAURUS;
	ComboBoxController1.ItemIndex:=3;
	SpinEditAxes1.Value:=1;
	SpinEditAxes1.Enabled:=False;
	ButtonTest1.Visible:=False;
	CheckBoxCalRm1.Visible:=False;
	EditCommand1.Text:='1 nversion';
	end
else if strId='Pegasus' then
	begin
	nControllerMode1:=WP2_CONTROLLER_PEGASUS;
	ComboBoxController1.ItemIndex:=4;
	SpinEditAxes1.Value:=4;
	ButtonTest1.Visible:=False;
	CheckBoxCalRm1.Visible:=False;
	EditCommand1.Text:='1 nversion';
	end
else if strId='Orion' then
	begin
	nControllerMode1:=WP2_CONTROLLER_ORION;
	ComboBoxController1.ItemIndex:=5;
	SpinEditAxes1.Value:=4;
	ButtonTest1.Visible:=False;
	CheckBoxCalRm1.Visible:=False;
	EditCommand1.Text:='1 nversion';
	end
else if strId='Corvus' then
	begin
	nControllerMode1:=WP2_CONTROLLER_CORVUS;
	ComboBoxController1.ItemIndex:=6;
	SpinEditAxes1.MaxValue:=3;
	SpinEditAxes1.Value:=3;
	end
else
	begin
	nControllerMode1:=WP2_CONTROLLER_DEFAULT;
	ComboBoxController1.ItemIndex:=0;
	SpinEditAxes1.MaxValue:=3;
	SpinEditAxes1.Value:=3;
	end;
SetupComboBoxBaudrate(nControllerMode1,ComboBoxBaudrate1);
strId:=MyIniFile.ReadString('Startup','CMode2','Default');
MyIniFile.Free;
if (strId='Delta')or(strId='Delta-PC') then
	begin
	nControllerMode2:=WP2_CONTROLLER_DELTA;
	ComboBoxController2.ItemIndex:=1;
	SpinEditAxes2.MaxValue:=4;
	SpinEditAxes2.Value:=4;
	end
else if strId='Alpha' then
	begin
	nControllerMode2:=WP2_CONTROLLER_ALPHA;
	ComboBoxController2.ItemIndex:=2;
	SpinEditAxes2.Value:=4;
	ButtonTest2.Visible:=False;
	CheckBoxCalRm2.Visible:=False;
	EditCommand2.Text:='1 nversion';
	end
else if strId='Taurus' then
	begin
	nControllerMode2:=WP2_CONTROLLER_TAURUS;
	ComboBoxController2.ItemIndex:=3;
	SpinEditAxes2.Value:=1;
	SpinEditAxes2.Enabled:=False;
	ButtonTest2.Visible:=False;
	CheckBoxCalRm2.Visible:=False;
	EditCommand2.Text:='1 nversion';
	end
else if strId='Pegasus' then
	begin
	nControllerMode2:=WP2_CONTROLLER_PEGASUS;
	ComboBoxController2.ItemIndex:=4;
	SpinEditAxes2.Value:=4;
	ButtonTest2.Visible:=False;
	CheckBoxCalRm2.Visible:=False;
	EditCommand2.Text:='1 nversion';
	end
else if strId='Orion' then
	begin
	nControllerMode2:=WP2_CONTROLLER_ORION;
	ComboBoxController2.ItemIndex:=5;
	SpinEditAxes2.Value:=4;
	ButtonTest2.Visible:=False;
	CheckBoxCalRm2.Visible:=False;
	EditCommand2.Text:='1 nversion';
	end
else if strId='Corvus' then
	begin
	nControllerMode2:=WP2_CONTROLLER_CORVUS;
	ComboBoxController2.ItemIndex:=6;
	SpinEditAxes2.MaxValue:=3;
	SpinEditAxes2.Value:=3;
	end
else
	begin
	nControllerMode2:=WP2_CONTROLLER_DEFAULT;
	ComboBoxController2.ItemIndex:=0;
	SpinEditAxes2.MaxValue:=3;
	SpinEditAxes2.Value:=3;
	end;
SetupComboBoxBaudrate(nControllerMode2,ComboBoxBaudrate2);
end;

procedure TFormMain.ButtonInit1Click(Sender: TObject);
var
	dwError:DWORD;
	dwMode:DWORD;
	dwBaudrate:DWORD;
begin
//dwMode:=2308+1048576;		//default value
dwMode:=1050884;
//dwMode:=$ffffffff;		//use Wp2Comm.ini
nAxes1:=SpinEditAxes1.Value;
nAxes2:=SpinEditAxes2.Value;
if Sender=ButtonInit2 then
	begin
	case ComboBoxController2.ItemIndex of
		1:nControllerMode2:=WP2_CONTROLLER_DELTA;
		2:nControllerMode2:=WP2_CONTROLLER_ALPHA;
		3:nControllerMode2:=WP2_CONTROLLER_TAURUS;
		4:nControllerMode2:=WP2_CONTROLLER_PEGASUS;
		5:nControllerMode2:=WP2_CONTROLLER_ORION;
		6:nControllerMode2:=WP2_CONTROLLER_CORVUS;
		else nControllerMode2:=WP2_CONTROLLER_DEFAULT;
		end;
//set nControllerMode to 0 if you want Wp2comm.dll use the value in wp2comm.ini,[Startup] (CMode=Delta, CMode=Alpha or CMode=Default)
	dwBaudrate:=StrToInt(ComboBoxBaudrate2.Text);
	dwError:=InitController2(nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE2,dwMode);
	if dwError<>0 then
		begin
		ShowMessage(Format('Wp2CommInit(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,dwMode,dwError]));
		exit;
		end;
	ButtonOpenController2.Enabled:=True;
	ActiveControl:=ButtonOpenController2;
	end
else
	begin
	case ComboBoxController1.ItemIndex of
		1:nControllerMode1:=WP2_CONTROLLER_DELTA;
		2:nControllerMode1:=WP2_CONTROLLER_ALPHA;
		3:nControllerMode1:=WP2_CONTROLLER_TAURUS;
		4:nControllerMode1:=WP2_CONTROLLER_PEGASUS;
		5:nControllerMode1:=WP2_CONTROLLER_ORION;
		6:nControllerMode1:=WP2_CONTROLLER_CORVUS;
		else nControllerMode1:=WP2_CONTROLLER_DEFAULT;
		end;
	dwBaudrate:=StrToInt(ComboBoxBaudrate1.Text);
	dwError:=InitController1(nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE1,dwMode);
	if dwError<>0 then
		begin
		ShowMessage(Format('Wp2CommInit(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,dwMode,dwError]));
		exit;
		end;
	ButtonOpenController1.Enabled:=True;
	ActiveControl:=ButtonOpenController1;
	end;
end;

procedure TFormMain.ButtonOpenController1Click(Sender: TObject);
var
	dwError:DWORD;
	strCaptionBk:string;
begin
if Sender=ButtonOpenController2 then
	begin
	ComboBoxController2.Enabled:=False;
	SpinEditAxes2.Enabled:=False;
	ComboBoxPort2.Enabled:=False;
	ComboBoxBaudrate2.Enabled:=False;
	strCaptionBk:=ButtonOpenController2.Caption;
	ButtonOpenController2.Caption:='Please wait...';
	dwError:=OpenController2;
	ButtonOpenController2.Caption:=strCaptionBk;
	end
else
	begin
	ComboBoxController1.Enabled:=False;
	SpinEditAxes1.Enabled:=False;
	ComboBoxPort1.Enabled:=False;
	ComboBoxBaudrate1.Enabled:=False;
	strCaptionBk:=ButtonOpenController1.Caption;
	ButtonOpenController1.Caption:='Please wait...';
	dwError:=OpenController1;
	ButtonOpenController1.Caption:=strCaptionBk;
	end;
if dwError<>0 then
	begin
	ShowMessage(Format('OpenController returned %d',[dwError]));
	if Sender=ButtonOpenController2 then
		begin
		ComboBoxController2.Enabled:=True;
		SpinEditAxes2.Enabled:=True;
		ComboBoxPort2.Enabled:=True;
		if nControllerMode2<>WP2_CONTROLLER_DELTA then
			ComboBoxBaudrate2.Enabled:=True;
		EditCommand2.Enabled:=False;
		if ButtonTest2.Visible=True then
			ButtonTest2.Enabled:=False;
		ButtonCloseController2.Enabled:=False;
		ActiveControl:=ButtonOpenController2;
		end
	else
		begin
		ComboBoxController1.Enabled:=True;
		SpinEditAxes1.Enabled:=True;
		ComboBoxPort1.Enabled:=True;
		if nControllerMode1<>WP2_CONTROLLER_DELTA then
			ComboBoxBaudrate1.Enabled:=True;
		EditCommand1.Enabled:=False;
		if ButtonTest1.Visible=True then
			ButtonTest1.Enabled:=False;
		ButtonCloseController1.Enabled:=False;
		ActiveControl:=ButtonOpenController1;
		end;
	exit;
	end;
if Sender=ButtonOpenController2 then
	begin
	ButtonOpenController2.Enabled:=False;
	ButtonCloseController2.Enabled:=True;
	EditCommand2.Enabled:=True;
	Memo2.Lines.Clear;
	if ButtonTest2.Visible=True then
		begin
		ButtonTest2.Enabled:=True;
		ActiveControl:=ButtonTest2;
		end
	else
		ActiveControl:=EditCommand2;
	end
else
	begin
	ButtonOpenController1.Enabled:=False;
	ButtonCloseController1.Enabled:=True;
	EditCommand1.Enabled:=True;
	Memo1.Lines.Clear;
	if ButtonTest1.Visible=True then
		begin
		ButtonTest1.Enabled:=True;
		ActiveControl:=ButtonTest1;
		end
	else
		ActiveControl:=EditCommand1;
	end;
end;

procedure TFormMain.DoExecuteCommand(nControllerId:Integer);
var
	dwError:DWORD;
begin
pReply[0][0]:=#0;
if nControllerId=2 then
	begin
	dwError:=ExecuteCommand2(PChar(EditCommand2.Text),SpinEditLinesToReply2.Value,pReply[0]);
	if dwError=0 then
		begin
		Memo2.Lines.Add(EditCommand2.Text);
		if pReply[0][0]<>#0 then
			Memo2.Lines.Add(StrPas(pReply[0]));
		end
	else
		begin
		ShowMessage(Format('ExecuteCommand(%s,%d,%s) returned =%d',
				[EditCommand2.Text,SpinEditLinesToReply2.Value,StrPas(pReply[0]),dwError]));
		end;
	end
else
	begin
	dwError:=ExecuteCommand1(PChar(EditCommand1.Text),SpinEditLinesToReply1.Value,pReply[0]);
	if dwError=0 then
		begin
		Memo1.Lines.Add(EditCommand1.Text);
		if pReply[0][0]<>#0 then
			Memo1.Lines.Add(StrPas(pReply[0]));
		end
	else
		begin
		ShowMessage(Format('ExecuteCommand(%s,%d,%s) returned =%d',
				[EditCommand1.Text,SpinEditLinesToReply1.Value,StrPas(pReply[0]),dwError]));
		end;
	end;
end;

procedure TFormMain.EditCommand1KeyPress(Sender: TObject; var Key: Char);
begin
if Key=#13 then
	begin
	if Sender=EditCommand2 then
		DoExecuteCommand(2)
	else
		DoExecuteCommand(1);
	Key:=#0;
	end;
end;

procedure TFormMain.ButtonCloseController1Click(Sender: TObject);
var
	dwError:DWORD;
begin
if Sender=ButtonCloseController2 then
	begin
	dwError:=CloseController2;
	if dwError=0 then
		begin
		ComboBoxController2.Enabled:=True;
		if nControllerMode2<>WP2_CONTROLLER_TAURUS then
			SpinEditAxes2.Enabled:=True;
		ComboBoxPort2.Enabled:=True;
		if nControllerMode2<>WP2_CONTROLLER_DELTA then
			ComboBoxBaudrate2.Enabled:=True;
		ButtonOpenController2.Enabled:=True;
		if ButtonTest2.Visible=True then
			ButtonTest2.Enabled:=False;
		ButtonCloseController2.Enabled:=False;
		EditCommand2.Enabled:=False;
		ActiveControl:=ButtonOpenController2;
		end;
	end
else
	begin
	dwError:=CloseController1;
	if dwError=0 then
		begin
		ComboBoxController1.Enabled:=True;
		if nControllerMode1<>WP2_CONTROLLER_TAURUS then
			SpinEditAxes1.Enabled:=True;
		ComboBoxPort1.Enabled:=True;
		if nControllerMode1<>WP2_CONTROLLER_DELTA then
			ComboBoxBaudrate1.Enabled:=True;
		ButtonOpenController1.Enabled:=True;
		if ButtonTest1.Visible=True then
			ButtonTest1.Enabled:=False;
		ButtonCloseController1.Enabled:=False;
		EditCommand1.Enabled:=False;
		ActiveControl:=ButtonOpenController1;
		end;
	end;
end;

procedure TFormMain.ButtonTest1Click(Sender: TObject);
begin
if Sender=ButtonTest2 then
	begin
	if DoTest2=False then
		begin
		ResetComm2;
		ShowMessage('Error processing test routine');
		end;
	end
else
	begin
	if DoTest1=False then
		begin
		ResetComm1;
		ShowMessage('Error processing test routine');
		end;
	end;
end;

function TFormMain.DoTest1:Boolean;
var
	i:Integer;
	dwError:DWORD;
	dwMode:DWORD;
	dwBaudrate:DWORD;
begin
Result:=False;
pReply[0][0]:=#0;
pReply[1][0]:=#0;
pReply[2][0]:=#0;
pReply[3][0]:=#0;
dwValue[0]:=0;
dwValue[1]:=0;
dwValue[2]:=0;
dwValue[3]:=0;
Memo1.Lines.Add('Processing ClearParameterStack ...');
if ClearParameterStack1>0 then
	exit;
Memo1.Lines.Add('Done');

if nControllerMode1<>WP2_CONTROLLER_DELTA then
//GetParamsOnStack() not defined for DeltaPC
	begin
	Memo1.Lines.Add('Processing GetParamsOnStack ...');
	if GetParamsOnStack1(@dwValue[0])>0 then
		exit;
	Memo1.Lines.Add(Format('%d',[dwValue[0]]));
	end;

Memo1.Lines.Add('Processing Identify ...');
if Identify1(pReply[0])>0 then
	exit;
Memo1.Lines.Add(pReply[0]);

Memo1.Lines.Add('Processing GetStatus ...');
if GetStatus1(@dwValue[0])>0 then
	exit;
Memo1.Lines.Add(Format('%d',[dwValue[0]]));

Memo1.Lines.Add('Processing GetError ...');
if GetError1(@dwValue[0])>0 then
	exit;
Memo1.Lines.Add(Format('%d',[dwValue[0]]));

for i:=0 to nAxes1-1 do
	begin
	if (i=nAxes1-1)and(nAxes1>1) then
		dwValue[i]:=0
	else
		dwValue[i]:=1;
	end;
Memo1.Lines.Add(Format('Processing SetAxisMode(%d,%d,%d,%d) ...',[dwValue[0],dwValue[1],dwValue[2],dwValue[3]]));
if SetAxisMode1(dwValue[0],dwValue[1],dwValue[2],dwValue[3])>0 then
	exit;
Memo1.Lines.Add('Done');

Memo1.Lines.Add('Processing GetAxisMode ...');
if GetAxisMode1(@dwValue[0],@dwValue[1],@dwValue[2],@dwValue[3])>0 then
	exit;
Memo1.Lines.Add(Format('%d %d %d %d',[dwValue[0],dwValue[1],dwValue[2],dwValue[3]]));

Memo1.Lines.Add('Processing SetVelocity(25,00) ...');
if SetVelocity1('25,00')>0 then
	exit;
Memo1.Lines.Add('Done');

Memo1.Lines.Add('Processing GetVelocity ...');
if GetVelocity1(pReply[0])>0 then
	exit;
Memo1.Lines.Add(pReply[0]);

Memo1.Lines.Add('Processing SetAcceleration(10,00) ...');
if SetAcceleration1('10,00')>0 then
	exit;
Memo1.Lines.Add('Done');

Memo1.Lines.Add('Processing GetAcceleration ...');
if GetAcceleration1(pReply[0])>0 then
	exit;
Memo1.Lines.Add(pReply[0]);

if nControllerMode1<>WP2_CONTROLLER_DELTA then
//Joystick functions not defined for DeltaPC
	begin
	Memo1.Lines.Add('Processing JoystickEnable ...');
	if JoystickEnable1>0 then
		exit;
	Memo1.Lines.Add('Done');

	Memo1.Lines.Add('Processing JoystickDisable ...');
	if JoystickDisable1>0 then
		exit;
	Memo1.Lines.Add('Done');

	Memo1.Lines.Add('Processing SetJoystickVelocity(5,00) ...');
	if SetJoystickVelocity1('5,00')>0 then
		exit;
	Memo1.Lines.Add('Done');

	Memo1.Lines.Add('Processing GetJoystickVelocity ...');
	if GetJoystickVelocity1(pReply[0])>0 then
		exit;
	Memo1.Lines.Add(pReply[0]);
	end;

Memo1.Lines.Add('Processing SetOrigin ...');
if SetOrigin1>0 then
	exit;
Memo1.Lines.Add('Done');

Memo1.Lines.Add('Processing MoveAbsolute(20,15,0,0) ...');
if MoveAbsolute1('20','15','0','0')>0 then
	exit;
while True do
	begin
	if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
		exit;
	Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));
	if GetStatus1(@dwValue[0])>0 then
		exit;
	dwValue[0]:=(dwValue[0])and(3);
	if (dwValue[0]=0)or(dwValue[0]=2) then
		break;
	end;
Memo1.Lines.Add('Done');
if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo1.Lines.Add('Processing MoveRelative(-5,-10,0,0) ...');
if MoveRelative1('-5','-10','0','0')>0 then
	exit;
while True do
	begin
	if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
		exit;
	Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));
	if GetStatus1(@dwValue[0])>0 then
		exit;
	dwValue[0]:=(dwValue[0])and(3);
	if (dwValue[0]=0)or(dwValue[0]=2) then
		break;
	end;
Memo1.Lines.Add('Done');
if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo1.Lines.Add('Processing MoveAbsoluteAutoReply(15,20,0,0) ...');
if MoveAbsoluteAutoReply1('15','20','0','0')>0 then
	exit;
if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo1.Lines.Add('Processing MoveRelativeAutoReply(-10,-10,0,0) ...');
if MoveRelativeAutoReply1('-10','-10','0','0')>0 then
	exit;
if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo1.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo1.Lines.Add('Processing GetPosAxis ...');
if GetPosAxis1(1,pReply[0])>0 then
	exit;
Memo1.Lines.Add(pReply[0]);

Memo1.Lines.Add('Processing GetPos ...');
if GetPos1(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo1.Lines.Add(Format('%s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

if CheckBoxCalRm1.Checked=True then
	begin
	Memo1.Lines.Add('Processing Calibrate ...');
	if Calibrate1>0 then
		exit;
	Memo1.Lines.Add('Done');
	Memo1.Lines.Add('Processing RangeMeasure ...');
	if RangeMeasure1>0 then
		exit;
	Memo1.Lines.Add('Done');
	end;

Memo1.Lines.Add('Processing GetLimits ...');
if GetLimits1(pReply[0],pReply[1],pReply[2],pReply[3],pReply[4],pReply[5],pReply[6],pReply[7])>0 then
	exit;
Memo1.Lines.Add(Format('Axis 1: %s | %s',[pReply[0],pReply[1]]));
if nAxes1>1 then
	Memo1.Lines.Add(Format('Axis 2: %s | %s',[pReply[2],pReply[3]]));
if nAxes1>2 then
	Memo1.Lines.Add(Format('Axis 3: %s | %s',[pReply[4],pReply[5]]));
if nAxes1>3 then
	Memo1.Lines.Add(Format('Axis 4: %s | %s',[pReply[6],pReply[7]]));

//switch to asynchronous mode
//dwMode:=2564+1048576;
dwMode:=1051140;
dwBaudrate:=StrToInt(ComboBoxBaudrate1.Text);
dwError:=InitController1(nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE1,dwMode);
if dwError<>0 then
	begin
	ShowMessage(Format('InitController(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,dwMode,dwError]));
	exit;
	end;
Memo1.Lines.Add('Processing GetError in asynchronous mode ...');
//execute GetError in asynchronous mode
GetError1(@dwValue[0]);

//switch back to synchronous mode
dwMode:=1050884;
dwBaudrate:=StrToInt(ComboBoxBaudrate1.Text);
dwError:=InitController1(nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE1,dwMode);
if dwError<>0 then
	begin
	ShowMessage(Format('InitController(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode1,nAxes1,ComboBoxPort1.ItemIndex+1,dwBaudrate,dwMode,dwError]));
	exit;
	end;
Result:=True;
end;

function TFormMain.DoTest2:Boolean;
var
	i:Integer;
	dwError:DWORD;
	dwMode:DWORD;
	dwBaudrate:DWORD;
begin
Result:=False;
pReply[0][0]:=#0;
pReply[1][0]:=#0;
pReply[2][0]:=#0;
pReply[3][0]:=#0;
dwValue[0]:=0;
dwValue[1]:=0;
dwValue[2]:=0;
dwValue[3]:=0;
Memo2.Lines.Add('Processing ClearParameterStack ...');
if ClearParameterStack2>0 then
	exit;
Memo2.Lines.Add('Done');

if nControllerMode2<>WP2_CONTROLLER_DELTA then
//GetParamsOnStack() not defined for DeltaPC
	begin
	Memo2.Lines.Add('Processing GetParamsOnStack ...');
	if GetParamsOnStack2(@dwValue[0])>0 then
		exit;
	Memo2.Lines.Add(Format('%d',[dwValue[0]]));
	end;

Memo2.Lines.Add('Processing Identify ...');
if Identify2(pReply[0])>0 then
	exit;
Memo2.Lines.Add(pReply[0]);

Memo2.Lines.Add('Processing GetStatus ...');
if GetStatus2(@dwValue[0])>0 then
	exit;
Memo2.Lines.Add(Format('%d',[dwValue[0]]));

Memo2.Lines.Add('Processing GetError ...');
if GetError2(@dwValue[0])>0 then
	exit;
Memo2.Lines.Add(Format('%d',[dwValue[0]]));

for i:=0 to nAxes2-1 do
	begin
	if (i=nAxes2-1)and(nAxes2>1) then
		dwValue[i]:=0
	else
		dwValue[i]:=1;
	end;
Memo2.Lines.Add(Format('Processing SetAxisMode(%d,%d,%d,%d) ...',[dwValue[0],dwValue[1],dwValue[2],dwValue[3]]));
if SetAxisMode2(dwValue[0],dwValue[1],dwValue[2],dwValue[3])>0 then
	exit;
Memo2.Lines.Add('Done');

Memo2.Lines.Add('Processing GetAxisMode ...');
if GetAxisMode2(@dwValue[0],@dwValue[1],@dwValue[2],@dwValue[3])>0 then
	exit;
Memo2.Lines.Add(Format('%d %d %d %d',[dwValue[0],dwValue[1],dwValue[2],dwValue[3]]));

Memo2.Lines.Add('Processing SetVelocity(25,00) ...');
if SetVelocity2('25,00')>0 then
	exit;
Memo2.Lines.Add('Done');

Memo2.Lines.Add('Processing GetVelocity ...');
if GetVelocity2(pReply[0])>0 then
	exit;
Memo2.Lines.Add(pReply[0]);

Memo2.Lines.Add('Processing SetAcceleration(10,00) ...');
if SetAcceleration2('10,00')>0 then
	exit;
Memo2.Lines.Add('Done');

Memo2.Lines.Add('Processing GetAcceleration ...');
if GetAcceleration2(pReply[0])>0 then
	exit;
Memo2.Lines.Add(pReply[0]);

if nControllerMode2<>WP2_CONTROLLER_DELTA then
//Joystick functions not defined for DeltaPC
	begin
	Memo2.Lines.Add('Processing JoystickEnable ...');
	if JoystickEnable2>0 then
		exit;
	Memo2.Lines.Add('Done');

	Memo2.Lines.Add('Processing JoystickDisable ...');
	if JoystickDisable2>0 then
		exit;
	Memo2.Lines.Add('Done');

	Memo2.Lines.Add('Processing SetJoystickVelocity(5,00) ...');
	if SetJoystickVelocity2('5,00')>0 then
		exit;
	Memo2.Lines.Add('Done');

	Memo2.Lines.Add('Processing GetJoystickVelocity ...');
	if GetJoystickVelocity2(pReply[0])>0 then
		exit;
	Memo2.Lines.Add(pReply[0]);
	end;

Memo2.Lines.Add('Processing SetOrigin ...');
if SetOrigin2>0 then
	exit;
Memo2.Lines.Add('Done');

Memo2.Lines.Add('Processing MoveAbsolute(20,15,0,0) ...');
if MoveAbsolute2('20','15','0','0')>0 then
	exit;
while True do
	begin
	if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
		exit;
	Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));
	if GetStatus2(@dwValue[0])>0 then
		exit;
	dwValue[0]:=(dwValue[0])and(3);
	if (dwValue[0]=0)or(dwValue[0]=2) then
		break;
	end;
Memo2.Lines.Add('Done');
if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo2.Lines.Add('Processing MoveRelative(-5,-10,0,0) ...');
if MoveRelative2('-5','-10','0','0')>0 then
	exit;
while True do
	begin
	if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
		exit;
	Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));
	if GetStatus2(@dwValue[0])>0 then
		exit;
	dwValue[0]:=(dwValue[0])and(3);
	if (dwValue[0]=0)or(dwValue[0]=2) then
		break;
	end;
Memo2.Lines.Add('Done');
if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo2.Lines.Add('Processing MoveAbsoluteAutoReply(15,20,0,0) ...');
if MoveAbsoluteAutoReply2('15','20','0','0')>0 then
	exit;
if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo2.Lines.Add('Processing MoveRelativeAutoReply(-10,-10,0,0) ...');
if MoveRelativeAutoReply2('-10','-10','0','0')>0 then
	exit;
if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo2.Lines.Add(Format('Pos. %s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

Memo2.Lines.Add('Processing GetPosAxis ...');
if GetPosAxis2(1,pReply[0])>0 then
	exit;
Memo2.Lines.Add(pReply[0]);

Memo2.Lines.Add('Processing GetPos ...');
if GetPos2(pReply[0],pReply[1],pReply[2],pReply[3])>0 then
	exit;
Memo2.Lines.Add(Format('%s %s %s %s',[pReply[0],pReply[1],pReply[2],pReply[3]]));

if CheckBoxCalRm2.Checked=True then
	begin
	Memo2.Lines.Add('Processing Calibrate ...');
	if Calibrate2>0 then
		exit;
	Memo2.Lines.Add('Done');
	Memo2.Lines.Add('Processing RangeMeasure ...');
	if RangeMeasure2>0 then
		exit;
	Memo2.Lines.Add('Done');
	end;

Memo2.Lines.Add('Processing GetLimits ...');
if GetLimits2(pReply[0],pReply[1],pReply[2],pReply[3],pReply[4],pReply[5],pReply[6],pReply[7])>0 then
	exit;
Memo2.Lines.Add(Format('Axis 1: %s | %s',[pReply[0],pReply[1]]));
if nAxes2>1 then
	Memo2.Lines.Add(Format('Axis 2: %s | %s',[pReply[2],pReply[3]]));
if nAxes2>2 then
	Memo2.Lines.Add(Format('Axis 3: %s | %s',[pReply[4],pReply[5]]));
if nAxes2>3 then
	Memo2.Lines.Add(Format('Axis 4: %s | %s',[pReply[6],pReply[7]]));

//switch to asynchronous mode
//dwMode:=2564+1048576;
dwMode:=1051140;
dwBaudrate:=StrToInt(ComboBoxBaudrate2.Text);
dwError:=InitController2(nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE2,dwMode);
if dwError<>0 then
	begin
	ShowMessage(Format('InitController(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,dwMode,dwError]));
	exit;
	end;
Memo2.Lines.Add('Processing GetError in asynchronous mode ...');
//execute GetError in asynchronous mode
GetError2(@dwValue[0]);

//switch back to synchronous mode
dwMode:=1050884;
dwBaudrate:=StrToInt(ComboBoxBaudrate2.Text);
dwError:=InitController2(nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCREPLYCOMPLETE2,dwMode);
if dwError<>0 then
	begin
	ShowMessage(Format('InitController(%d,%d,%d,%d,%d) returned Error %d',[nControllerMode2,nAxes2,ComboBoxPort2.ItemIndex+1,dwBaudrate,dwMode,dwError]));
	exit;
	end;
Result:=True;
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if ((Key=Word('B'))and(Shift=[ssCtrl])) then
	begin
	if ButtonCloseController1.Enabled=true then
		AbortCommand1;
	if ButtonCloseController2.Enabled=true then
		AbortCommand2;
	Key:=0;
	end;
end;

procedure TFormMain.WMUAsyncReplyComplete1(var Msg:TMessage);
var
	pReply:PChar;
	dwError:DWORD;
begin
if Msg.wParam=21 then
	begin
	ResetComm1;
	ShowMessage('BREAK detected!');
	end
else
	begin
	pReply:=StrAlloc(256);
	if pReply=nil then
		exit;
	pReply[0]:=#0;
	dwError:=GetReply1(pReply);
	if dwError=0 then
		Memo1.Lines.Add(pReply)
	else
		ShowMessage(Format('Controller reply error >%d<',[dwError]));
	ActiveControl:=EditCommand1;
	StrDispose(pReply);
	end;
end;

procedure TFormMain.WMUAsyncReplyComplete2(var Msg:TMessage);
var
	pReply:PChar;
	dwError:DWORD;
begin
if Msg.wParam=21 then
	begin
	ResetComm2;
	ShowMessage('BREAK detected!');
	end
else
	begin
	pReply:=StrAlloc(256);
	if pReply=nil then
		exit;
	pReply[0]:=#0;
	dwError:=GetReply2(pReply);
	if dwError=0 then
		Memo2.Lines.Add(pReply)
	else
		ShowMessage(Format('Controller reply error >%d<',[dwError]));
	ActiveControl:=EditCommand2;
	StrDispose(pReply);
	end;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
	i:Integer;
begin
if ButtonCloseController1.Enabled=True then
	CloseController1;
if ButtonCloseController2.Enabled=True then
	CloseController2;
for i:=0 to 7 do
	StrDispose(pReply[i]);
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
Memo1.Width:=Panel1.Width-2*Memo1.Left;
Memo2.Width:=Panel2.Width-2*Memo2.Left;
end;

procedure TFormMain.ComboBoxController1Change(Sender: TObject);
begin
if Sender=ComboBoxController2 then
	begin
	if ComboBoxController2.ItemIndex=1 then
		begin
		nControllerMode2:=WP2_CONTROLLER_DELTA;
		SpinEditAxes2.MaxValue:=4;
		SpinEditAxes2.Value:=4;
		SpinEditAxes2.Enabled:=True;
		ButtonTest2.Visible:=True;
		CheckBoxCalRm2.Visible:=True;
		EditCommand2.Text:='version';
		end
	else if ComboBoxController2.ItemIndex=2 then
		begin
		nControllerMode2:=WP2_CONTROLLER_ALPHA;
		SpinEditAxes2.MaxValue:=16;
		SpinEditAxes2.Value:=4;
		SpinEditAxes2.Enabled:=True;
		ButtonTest2.Visible:=False;
		CheckBoxCalRm2.Visible:=False;
		EditCommand2.Text:='1 nversion';
		end
	else if ComboBoxController2.ItemIndex=3 then
		begin
		nControllerMode2:=WP2_CONTROLLER_TAURUS;
		SpinEditAxes2.MaxValue:=1;
		SpinEditAxes2.Value:=1;
		SpinEditAxes2.Enabled:=False;
		ButtonTest2.Visible:=False;
		CheckBoxCalRm2.Visible:=False;
		EditCommand2.Text:='1 nversion';
		end
	else if ComboBoxController2.ItemIndex=4 then
		begin
		nControllerMode2:=WP2_CONTROLLER_PEGASUS;
		SpinEditAxes2.MaxValue:=100;
		SpinEditAxes2.Value:=4;
		SpinEditAxes2.Enabled:=True;
		ButtonTest2.Visible:=False;
		CheckBoxCalRm2.Visible:=False;
		EditCommand2.Text:='1 nversion';
		end
	else if ComboBoxController2.ItemIndex=5 then
		begin
		nControllerMode2:=WP2_CONTROLLER_ORION;
		SpinEditAxes2.MaxValue:=100;
		SpinEditAxes2.Value:=4;
		SpinEditAxes2.Enabled:=True;
		ButtonTest2.Visible:=False;
		CheckBoxCalRm2.Visible:=False;
		EditCommand2.Text:='1 nversion';
		end
	else if ComboBoxController2.ItemIndex=6 then
		begin
		nControllerMode2:=WP2_CONTROLLER_CORVUS;
		SpinEditAxes2.MaxValue:=3;
		SpinEditAxes2.Value:=3;
		SpinEditAxes2.Enabled:=True;
		ButtonTest2.Visible:=True;
		CheckBoxCalRm2.Visible:=True;
		EditCommand2.Text:='version';
		end
	else
		begin
		nControllerMode2:=WP2_CONTROLLER_DEFAULT;
		SpinEditAxes2.MaxValue:=3;
		SpinEditAxes2.Value:=3;
		ButtonTest2.Visible:=True;
		CheckBoxCalRm2.Visible:=True;
		EditCommand2.Text:='version';
		end;
	SetupComboBoxBaudrate(nControllerMode2,ComboBoxBaudrate2);
	end
else
	begin
	if ComboBoxController1.ItemIndex=1 then
		begin
		nControllerMode1:=WP2_CONTROLLER_DELTA;
		SpinEditAxes1.MaxValue:=4;
		SpinEditAxes1.Value:=4;
		SpinEditAxes1.Enabled:=True;
		ButtonTest1.Visible:=True;
		CheckBoxCalRm1.Visible:=True;
		EditCommand1.Text:='version';
		end
	else if ComboBoxController1.ItemIndex=2 then
		begin
		nControllerMode1:=WP2_CONTROLLER_ALPHA;
		SpinEditAxes1.MaxValue:=16;
		SpinEditAxes1.Value:=4;
		SpinEditAxes1.Enabled:=True;
		ButtonTest1.Visible:=False;
		CheckBoxCalRm1.Visible:=False;
		EditCommand1.Text:='1 nversion';
		end
	else if ComboBoxController1.ItemIndex=3 then
		begin
		nControllerMode1:=WP2_CONTROLLER_TAURUS;
		SpinEditAxes1.MaxValue:=1;
		SpinEditAxes1.Value:=1;
		SpinEditAxes1.Enabled:=False;
		ButtonTest1.Visible:=False;
		CheckBoxCalRm1.Visible:=False;
		EditCommand1.Text:='1 nversion';
		end
	else if ComboBoxController1.ItemIndex=4 then
		begin
		nControllerMode1:=WP2_CONTROLLER_PEGASUS;
		SpinEditAxes1.MaxValue:=100;
		SpinEditAxes1.Value:=4;
		SpinEditAxes1.Enabled:=True;
		ButtonTest1.Visible:=False;
		CheckBoxCalRm1.Visible:=False;
		EditCommand1.Text:='1 nversion';
		end
	else if ComboBoxController1.ItemIndex=5 then
		begin
		nControllerMode1:=WP2_CONTROLLER_ORION;
		SpinEditAxes1.MaxValue:=100;
		SpinEditAxes1.Value:=4;
		SpinEditAxes1.Enabled:=True;
		ButtonTest1.Visible:=False;
		CheckBoxCalRm1.Visible:=False;
		EditCommand1.Text:='1 nversion';
		end
	else if ComboBoxController1.ItemIndex=6 then
		begin
		nControllerMode1:=WP2_CONTROLLER_CORVUS;
		SpinEditAxes1.MaxValue:=3;
		SpinEditAxes1.Value:=3;
		SpinEditAxes1.Enabled:=True;
		ButtonTest1.Visible:=True;
		CheckBoxCalRm1.Visible:=True;
		EditCommand1.Text:='version';
		end
	else
		begin
		nControllerMode1:=WP2_CONTROLLER_DEFAULT;
		SpinEditAxes1.MaxValue:=3;
		SpinEditAxes1.Value:=3;
		ButtonTest1.Visible:=True;
		CheckBoxCalRm1.Visible:=True;
		EditCommand1.Text:='version';
		end;
	SetupComboBoxBaudrate(nControllerMode1,ComboBoxBaudrate1);
	end;
end;

procedure TFormMain.SetupComboBoxBaudrate(nMode:Integer;CBBaudrate:TComboBox);
begin
CBBaudrate.Items.Clear();
CBBaudrate.Items.Add('19200');
CBBaudrate.Items.Add('9600');
CBBaudrate.Items.Add('4800');
CBBaudrate.Items.Add('2400');
CBBaudrate.Items.Add('1200');
case(nMode) of
WP2_CONTROLLER_DELTA:
	begin
	CBBaudrate.ItemIndex:=CBBaudrate.Items.IndexOf('9600');
	CBBaudrate.Enabled:=false;
	end;
WP2_CONTROLLER_CORVUS:
	begin
	CBBaudrate.Items.Insert(0,'57600');
	CBBaudrate.Items.Insert(0,'115200');
	CBBaudrate.ItemIndex:=CBBaudrate.Items.IndexOf('115200');
	CBBaudrate.Enabled:=True;
	end;
WP2_CONTROLLER_ALPHA,
WP2_CONTROLLER_TAURUS,
WP2_CONTROLLER_PEGASUS,
WP2_CONTROLLER_ORION,
WP2_CONTROLLER_DEFAULT:
	begin
	CBBaudrate.ItemIndex:=CBBaudrate.Items.IndexOf('9600');
	CBBaudrate.Enabled:=True;
	end;
else
	begin
	CBBaudrate.ItemIndex:=CBBaudrate.Items.IndexOf('19200');
	CBBaudrate.Enabled:=True;
	end;
	end;	//case
end;

end.

