//---------------------------------------------------------------------------
#ifndef Wp2Demo_MainH
#define Wp2Demo_MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "CSPIN.h"

#define	WMU_ASYNCMSG	WM_USER+10

//nControllerMode
#define	WP2_CONTROLLER_DEFAULT		1
#define	WP2_CONTROLLER_DELTA		2
#define	WP2_CONTROLLER_ALPHA		4
#define	WP2_CONTROLLER_TAURUS		8
#define	WP2_CONTROLLER_PEGASUS		16
#define	WP2_CONTROLLER_ORION		32
#define	WP2_CONTROLLER_CORVUS		64
#define	WP2_CONTROLLER_POLLUX		128

//---------------------------------------------------------------------------
class TFormWp2Demo : public TForm
{
__published:	// Komponenten, die von der IDE verwaltet werden
	TButton *ButtonOpen;
	TButton *ButtonClose;
	TButton *ButtonTest;
	TCheckBox *CheckBoxCalibrate;
	TGroupBox *GroupBoxVenusCommand;
	TEdit *EditCommand;
	TMemo *Memo1;
	TLabel *Label2;
	TLabel *Label3;
	TCSpinEdit *CSpinEditLinesExpected;
	TGroupBox *GroupBoxInit;
	TLabel *Label6;
	TComboBox *ComboBoxController;
	TLabel *Label1;
	TComboBox *ComboBoxPort;
	TLabel *Label4;
	TComboBox *ComboBoxBaudrate;
	TLabel *Label5;
	TCSpinEdit *CSpinEditAxes;
	TButton *ButtonInit;
	TCheckBox *CheckBoxAsyncMode;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ButtonInitClick(TObject *Sender);
	void __fastcall ButtonOpenClick(TObject *Sender);
	void __fastcall ButtonCloseClick(TObject *Sender);
	void __fastcall ButtonTestClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
		TShiftState Shift);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall EditCommandKeyPress(TObject *Sender, char &Key);
	void __fastcall FormResize(TObject *Sender);

	void __fastcall ComboBoxControllerChange(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
private:	// Benutzerdeklarationen
	int		nControllerMode;
	char		*pReply[8];
	DWORD	dwValue[4];
	void		SetupComboBoxBaudrate(int nMode);
	bool		DoTest();
	bool		DoDefaultTest();
	bool		DoAlphaTest(int Axis);
public:		// Benutzerdeklarationen
	__fastcall TFormWp2Demo(TComponent* Owner);
	virtual void __fastcall	Dispatch(void *Message);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormWp2Demo *FormWp2Demo;
//---------------------------------------------------------------------------
#endif
