// Wp2DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Wp2Demo.h"
#include "Wp2DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef DWORD (__stdcall *pInitController)(DWORD CMode,DWORD Axes,DWORD Port, DWORD Baudrate,HWND UserWin,UINT UserMsg,DWORD Mode);
typedef DWORD (__stdcall *pOpenController)();
typedef DWORD (__stdcall *pCloseController)();
typedef DWORD (__stdcall *pExecuteCommand)(LPSTR pCommand, DWORD Lines, LPSTR pData);
typedef DWORD (__stdcall *pGetReply)(LPSTR pData);
typedef DWORD (__stdcall *pIdentify)(LPSTR pData);
typedef DWORD (__stdcall *pGetStatus)(LPDWORD pData);
typedef DWORD (__stdcall *pGetError)(LPDWORD pData);
typedef DWORD (__stdcall *pSetVelocity)(LPSTR pData);
typedef DWORD (__stdcall *pGetVelocity)(LPSTR pData);
typedef DWORD (__stdcall *pJoystickEnable)();
typedef DWORD (__stdcall *pSetOrigin)();
typedef DWORD (__stdcall *pGetPos)(LPSTR Axis1Pos,LPSTR Axis2Pos,LPSTR Axis3Pos,LPSTR Axis4Pos);
typedef DWORD (__stdcall *pMoveAbsolute)(LPSTR Axis1Pos,LPSTR Axis2Pos,LPSTR Axis3Pos,LPSTR Axis4Pos);
typedef DWORD (__stdcall *pMoveRelativeAutoReply)(LPSTR Axis1Pos,LPSTR Axis2Pos,LPSTR Axis3Pos,LPSTR Axis4Pos);


/////////////////////////////////////////////////////////////////////////////
// CWp2DemoDlg dialog

CWp2DemoDlg::CWp2DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWp2DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWp2DemoDlg)
	m_EditCommand = _T("");
	m_EditLines = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWp2DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWp2DemoDlg)
	DDX_Control(pDX, IDC_COMBO_BAUDRATE, m_ComboBaudrate);
	DDX_Control(pDX, IDC_COMBO_PORT, m_ComboPort);
	DDX_Control(pDX, IDC_COMBO_AXES, m_ComboAxes);
	DDX_Control(pDX, IDC_COMBO_CONTROLLER, m_ComboController);
	DDX_Control(pDX, IDC_BUTTONEXECUTE, m_Execute);
	DDX_Control(pDX, IDC_LISTDATA, m_ListData);
	DDX_Control(pDX, IDC_BUTTONTEST, m_Test);
	DDX_Control(pDX, IDC_BUTTONOPEN, m_OpenController);
	DDX_Control(pDX, IDC_BUTTONINIT, m_InitController);
	DDX_Control(pDX, IDC_BUTTONCLOSE, m_CloseController);
	DDX_Text(pDX, IDC_EDITCOMMAND, m_EditCommand);
	DDX_Text(pDX, IDC_EDITLINES, m_EditLines);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWp2DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CWp2DemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONINIT, OnButtoninit)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTONOPEN, OnButtonopen)
	ON_BN_CLICKED(IDC_BUTTONCLOSE, OnButtonclose)
	ON_BN_CLICKED(IDC_BUTTONTEST, OnButtontest)
	ON_BN_CLICKED(IDC_BUTTONEXECUTE, OnButtonexecute)
	ON_CBN_SELCHANGE(IDC_COMBO_CONTROLLER, OnSelchangeComboController)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WMU_ASYNCMSG,OnAsyncMsg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWp2DemoDlg message handlers

BOOL CWp2DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	int					i,nLen;
	DWORD	dwSuccess;
	char			Buf[128];
	char			acIniName[256];
	hWp2CommDll=0;
	acIniName[0]=0;
	if (GetModuleFileName(NULL,acIniName,sizeof(acIniName)))
	{
		nLen=strlen(acIniName);
		for (i=nLen-1;i>0;i--)
		{
			if (acIniName[i]=='\\')
				acIniName[i]=0;
		}
	}
	strcat(acIniName,"Wp2comm.ini");
	dwSuccess=GetPrivateProfileString("Startup","CMode","Default",Buf,128,acIniName);
	if ((strcmp(Buf,"Delta")==0)||(strcmp(Buf,"Delta-PC")==0))
	{
		dwControllerMode=WP2_CONTROLLER_DELTA;
		m_ComboController.SetCurSel(1);
		m_EditCommand="version";
		dwAxes=4;
	}
	else if (strcmp(Buf,"Alpha")==0)
	{
		dwControllerMode=WP2_CONTROLLER_ALPHA;
		m_ComboController.SetCurSel(2);
		m_Test.ShowWindow(SW_HIDE);
		m_EditCommand="1 nversion";
		dwAxes=4;
	}
	else if (strcmp(Buf,"Taurus")==0)
	{
		dwControllerMode=WP2_CONTROLLER_TAURUS;
		m_ComboController.SetCurSel(3);
		m_ComboAxes.EnableWindow(FALSE);
		m_Test.ShowWindow(SW_HIDE);
		m_EditCommand="1 nversion";
		dwAxes=1;
	}
	else if (strcmp(Buf,"Pegasus")==0)
	{
		dwControllerMode=WP2_CONTROLLER_PEGASUS;
		m_ComboController.SetCurSel(4);
		m_Test.ShowWindow(SW_HIDE);
		m_EditCommand="1 nversion";
		dwAxes=4;
	}
	else if (strcmp(Buf,"Orion")==0)
	{
		dwControllerMode=WP2_CONTROLLER_ORION;
		m_ComboController.SetCurSel(5);
		m_Test.ShowWindow(SW_HIDE);
		m_EditCommand="1 nversion";
		dwAxes=4;
	}
	else if (strcmp(Buf,"Corvus")==0)
	{
		dwControllerMode=WP2_CONTROLLER_CORVUS;
		m_ComboController.SetCurSel(6);
		m_EditCommand="version";
		dwAxes=3;
	}
	else if (strcmp(Buf,"Pollux")==0)
	{
		dwControllerMode=WP2_CONTROLLER_POLLUX;
		m_ComboController.SetCurSel(7);
		m_Test.ShowWindow(SW_HIDE);
		m_EditCommand="1 nversion";
		dwAxes=2;
	}
	else
	{
		dwControllerMode=WP2_CONTROLLER_DEFAULT;
		m_ComboController.SetCurSel(0);
		m_ComboAxes.DeleteString(0);
		m_EditCommand="version";
		dwAxes=3;
	}
	m_EditLines=1;
	m_ComboAxes.SetCurSel(m_ComboAxes.GetCount()-dwAxes);
	m_ComboPort.SetCurSel(1);
	UpdateData(FALSE);
	SetupComboBoxBaudrate(dwControllerMode);
		
	m_InitController.SetFocus();
	m_InitController.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
//	return TRUE;  // return TRUE  unless you set the focus to a control
	return FALSE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWp2DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWp2DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CWp2DemoDlg::OnAsyncMsg(WPARAM wParam,LPARAM lParam)
{
	DWORD	dwSuccess;
	char		Data[256];
	pGetReply	Wp2CommGetReply;
	if (wParam==21)
		AfxMessageBox("BREAK detected.");
	else
	{
		Wp2CommGetReply=(pGetReply)GetProcAddress(hWp2CommDll,"GetReply");
		dwSuccess=(*Wp2CommGetReply)(Data);
		if (dwSuccess)
		{
			AfxMessageBox("Unable to process GetReply!");
			return(1);
		}
		if ((Data[strlen(Data)-2]=='\r')&&(Data[strlen(Data)-1]=='\n'))
				Data[strlen(Data)-2]=0;
		m_ListData.AddString(Data);
		m_ListData.AddString("");
		m_ListData.AddString("Test successful!");
		m_ListData.SetTopIndex(m_ListData.GetCount()-8);
	}
	return(0);
}

void CWp2DemoDlg::OnButtoninit() 
{
	DWORD	dwSuccess;
	DWORD	dwBaudrate;
	int					nPort;
	char			acBuf[256];
	pInitController	Wp2CommInitController;
	// TODO: Add your control notification handler code here
	hWp2CommDll=LoadLibrary("WP2COMM.DLL");
	if (hWp2CommDll==NULL)
	{
		AfxMessageBox("Unable to load WP2COMM.DLL");
		return;
	}
	Wp2CommInitController=(pInitController)GetProcAddress(hWp2CommDll,"InitController");
	if (Wp2CommInitController==0)
	{
		AfxMessageBox("GetProcAddress-Error (InitController)");
		return;
	}
	UpdateData(TRUE);
	m_ComboController.GetLBText(m_ComboController.GetCurSel(),acBuf);
	if (strcmp(acBuf,"Delta-PC")==0)
		dwControllerMode=WP2_CONTROLLER_DELTA;
	else if (strcmp(acBuf,"Alpha")==0)
		dwControllerMode=WP2_CONTROLLER_ALPHA;
	else if (strcmp(acBuf,"Taurus")==0)
		dwControllerMode=WP2_CONTROLLER_TAURUS;
	else if (strcmp(acBuf,"Pegasus")==0)
		dwControllerMode=WP2_CONTROLLER_PEGASUS;
	else if (strcmp(acBuf,"Orion")==0)
		dwControllerMode=WP2_CONTROLLER_ORION;
	else if (strcmp(acBuf,"Corvus")==0)
		dwControllerMode=WP2_CONTROLLER_CORVUS;
	else if (strcmp(acBuf,"Pollux")==0)
		dwControllerMode=WP2_CONTROLLER_POLLUX;
	else
		dwControllerMode=WP2_CONTROLLER_DEFAULT;
	dwBaudrate=GetDlgItemInt(IDC_COMBO_BAUDRATE);
	m_ComboAxes.GetLBText(m_ComboAxes.GetCurSel(),acBuf);
	dwAxes=atoi(acBuf);
	nPort=m_ComboPort.GetCurSel()+1;
	dwSuccess=(*Wp2CommInitController)(dwControllerMode,dwAxes,nPort,dwBaudrate,GetSafeHwnd(),WMU_ASYNCMSG,1050884);
	if (dwSuccess)
	{
		AfxMessageBox("Unable to initialize controller!");
		return;
	}
	m_InitController.SetButtonStyle(BS_PUSHBUTTON,TRUE);
	m_OpenController.EnableWindow(TRUE);
	m_OpenController.SetFocus();
	m_OpenController.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
}

void CWp2DemoDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if (hWp2CommDll)
		FreeLibrary(hWp2CommDll);
	CDialog::OnClose();
}

void CWp2DemoDlg::OnButtonopen() 
{
	// TODO: Add your control notification handler code here
	DWORD	dwSuccess;
	pOpenController		Wp2CommOpenController;
	m_ComboController.EnableWindow(FALSE);
	m_ComboAxes.EnableWindow(FALSE);
	m_ComboPort.EnableWindow(FALSE);
	m_ComboBaudrate.EnableWindow(FALSE);
	Wp2CommOpenController=(pOpenController)GetProcAddress(hWp2CommDll,"OpenController");
	dwSuccess=(*Wp2CommOpenController)();
	if (dwSuccess)
	{
		AfxMessageBox("Unable to open controller!");
		m_ComboController.EnableWindow(TRUE);
		m_ComboAxes.EnableWindow(TRUE);
		m_ComboPort.EnableWindow(TRUE);
		if (dwControllerMode!=WP2_CONTROLLER_DELTA)
			m_ComboBaudrate.EnableWindow(TRUE);
		return;
	}
	m_OpenController.SetButtonStyle(BS_PUSHBUTTON,TRUE);
	m_OpenController.EnableWindow(FALSE);
	m_CloseController.EnableWindow(TRUE);
	m_ListData.ResetContent();
	m_Execute.EnableWindow(TRUE);
	if (m_Test.IsWindowVisible())
	{
		m_Test.EnableWindow(TRUE);
		m_Test.SetFocus();
		m_Test.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
	}
	else
	{
		m_Execute.SetFocus();
		m_Execute.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
	}
}

void CWp2DemoDlg::OnButtonclose() 
{
	// TODO: Add your control notification handler code here
	DWORD	dwSuccess;
	pCloseController		Wp2CommCloseController;
	Wp2CommCloseController=(pCloseController)GetProcAddress(hWp2CommDll,"CloseController");
	dwSuccess=(*Wp2CommCloseController)();
	if (dwSuccess)
	{
		AfxMessageBox("Unable to close controller!");
		return;
	}
	m_ComboController.EnableWindow(TRUE);
	if (dwControllerMode!=WP2_CONTROLLER_TAURUS)
		m_ComboAxes.EnableWindow(TRUE);
	m_ComboPort.EnableWindow(TRUE);
	if (dwControllerMode!=WP2_CONTROLLER_DELTA)
		m_ComboBaudrate.EnableWindow(TRUE);
	m_OpenController.EnableWindow(TRUE);
	m_CloseController.EnableWindow(FALSE);
	if (m_Test.IsWindowVisible())
		m_Test.EnableWindow(FALSE);
	m_Execute.EnableWindow(FALSE);
	m_OpenController.SetFocus();
	m_OpenController.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
}

void CWp2DemoDlg::OnButtontest() 
{
	// TODO: Add your control notification handler code here
	DWORD	dwSuccess;
	DWORD	dwData;
	DWORD	dwBaudrate;
	char	Data0[256];
	char	Data1[256];
	char	Data2[256];
	char	Data3[256];
	char	Data4[256];
	pInitController	Wp2CommInitController;
	pIdentify		Wp2CommIdentify;
	pGetStatus		Wp2CommGetStatus;
	pGetError		Wp2CommGetError;
	pSetVelocity		Wp2CommSetVelocity;
	pGetVelocity		Wp2CommGetVelocity;
	pJoystickEnable		Wp2CommJoystickEnable;
	pSetOrigin		Wp2CommSetOrigin;
	pMoveAbsolute		Wp2CommMoveAbsolute;
	pMoveRelativeAutoReply		Wp2CommMoveRelativeAutoReply;
	pGetPos		Wp2CommGetPos;

	m_ListData.AddString("Processing Testroutines!");
	m_ListData.AddString("");
	Wp2CommIdentify=(pIdentify)GetProcAddress(hWp2CommDll,"Identify");
	m_ListData.AddString("Processing Identify ...");
	dwSuccess=(*Wp2CommIdentify)(Data1);
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process Identify!");
		return;
	}
	m_ListData.AddString(Data1);

	Wp2CommGetStatus=(pGetStatus)GetProcAddress(hWp2CommDll,"GetStatus");
	m_ListData.AddString("Processing GetStatus ...");
	dwSuccess=(*Wp2CommGetStatus)(&dwData);
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process GetStatus!");
		return;
	}
	sprintf(Data0,"%d",dwData);
	m_ListData.AddString((CString)Data0);

	Wp2CommGetError=(pGetError)GetProcAddress(hWp2CommDll,"GetError");
	m_ListData.AddString("Processing GetError ...");
	dwSuccess=(*Wp2CommGetError)(&dwData);
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process GetError!");
		return;
	}
	sprintf(Data0,"%d",dwData);
	m_ListData.AddString((CString)Data0);
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

	Wp2CommSetVelocity=(pSetVelocity)GetProcAddress(hWp2CommDll,"SetVelocity");
	m_ListData.AddString("Processing SetVelocity(25.0) ...");
	dwSuccess=(*Wp2CommSetVelocity)("25.0");
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process SetVelocity!");
		return;
	}
	m_ListData.AddString("Done");
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

	Wp2CommGetVelocity=(pGetVelocity)GetProcAddress(hWp2CommDll,"GetVelocity");
	m_ListData.AddString("Processing GetVelocity ...");
	dwSuccess=(*Wp2CommGetVelocity)(Data1);
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process GetVelocity!");
		return;
	}
	m_ListData.AddString(Data1);
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

	if (dwControllerMode==WP2_CONTROLLER_DEFAULT)
	{
		Wp2CommJoystickEnable=(pJoystickEnable)GetProcAddress(hWp2CommDll,"JoystickEnable");
		m_ListData.AddString("Processing JoystickEnable ...");
		dwSuccess=(*Wp2CommJoystickEnable)();
		if (dwSuccess)
		{
			AfxMessageBox("Unable to process JoystickEnable!");
			return;
		}
		m_ListData.AddString("Done");
		m_ListData.SetTopIndex(m_ListData.GetCount()-8);
	}

	Wp2CommSetOrigin=(pSetOrigin)GetProcAddress(hWp2CommDll,"SetOrigin");
	m_ListData.AddString("Processing SetOrigin ...");
	dwSuccess=(*Wp2CommSetOrigin)();
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process SetOrigin!");
		return;
	}
	m_ListData.AddString("Done");
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

	Wp2CommMoveAbsolute=(pMoveAbsolute)GetProcAddress(hWp2CommDll,"MoveAbsolute");
	Wp2CommGetPos=(pGetPos)GetProcAddress(hWp2CommDll,"GetPos");
	m_ListData.AddString("Processing MoveAbsolute(20,15,0) ...");
	dwSuccess=(*Wp2CommMoveAbsolute)("20","15","0","0");
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process Wp2CommMoveAbsolute()!");
		return;
	}
	while (TRUE)
	{
		Data1[0]=0;
		Data2[0]=0;
		Data3[0]=0;
		Data4[0]=0;
		if ((*Wp2CommGetPos)(Data1,Data2,Data3,Data4))
			return;
		sprintf(Data0,"%s %s %s %s",Data1,Data2,Data3,Data4);
		m_ListData.AddString(Data0);
		m_ListData.SetTopIndex(m_ListData.GetCount()-8);
		if ((*Wp2CommGetStatus)(&dwData))
			return;
		dwData=dwData&3;
		if ((dwData==0)||(dwData==2))
			break;
	}
	m_ListData.AddString("Done");
	Data1[0]=0;
	Data2[0]=0;
	Data3[0]=0;
	Data4[0]=0;
	if ((*Wp2CommGetPos)(Data1,Data2,Data3,Data4))
		return;
	sprintf(Data0,"%s %s %s %s",Data1,Data2,Data3,Data4);
	m_ListData.AddString(Data0);
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

	Wp2CommMoveRelativeAutoReply=(pMoveRelativeAutoReply)GetProcAddress(hWp2CommDll,"MoveRelativeAutoReply");
	m_ListData.AddString("Processing MoveRelativeAutoReply(-10,-10,0,0) ...");
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);
	dwSuccess=(*Wp2CommMoveRelativeAutoReply)("-10","-10","0","0");
	if (dwSuccess)
	{
		AfxMessageBox("Unable to process MoveRelativeAutoReply!");
		return;
	}
	m_ListData.AddString("Done");
	Data1[0]=0;
	Data2[0]=0;
	Data3[0]=0;
	Data4[0]=0;
	if ((*Wp2CommGetPos)(Data1,Data2,Data3,Data4))
		return;
	sprintf(Data0,"%s %s %s %s",Data1,Data2,Data3,Data4);
	m_ListData.AddString(Data0);
	m_ListData.SetTopIndex(m_ListData.GetCount()-8);

//switch to asynchronous mode
	Wp2CommInitController=(pInitController)GetProcAddress(hWp2CommDll,"InitController");
	dwBaudrate=GetDlgItemInt(IDC_COMBO_BAUDRATE);
	dwSuccess=(*Wp2CommInitController)(dwControllerMode,dwAxes,m_ComboPort.GetCurSel()+1,dwBaudrate,GetSafeHwnd(),WMU_ASYNCMSG,1051140);
	if (dwSuccess)
	{
		AfxMessageBox("Error switching to asynchronous mode");
		return;
	}
	m_ListData.AddString("Processing async. GetError ...");
//execute GetError in asynchronous mode
	(*Wp2CommGetError)(&dwData);

//switch back to synchronous mode
	if ((*Wp2CommInitController)(dwControllerMode,dwAxes,m_ComboPort.GetCurSel()+1,dwBaudrate,GetSafeHwnd(),WMU_ASYNCMSG,1050884))
	{
		AfxMessageBox("Error switching back to synchronous mode");
		return;
	}
	if (m_Test.IsWindowVisible())
	{
		m_Test.SetButtonStyle(BS_PUSHBUTTON,TRUE);
		m_Execute.SetFocus();
		m_Execute.SetButtonStyle(BS_DEFPUSHBUTTON,TRUE);
	}
//resize the listbox to display the whole data
SIZE	TextSize;
CDC		*pLBDC;
pLBDC=m_ListData.GetDC();
if (pLBDC)
{
	TextSize=pLBDC->GetTextExtent("Processing MoveRelativeAutoReply(-10,-10,0,0) ...",strlen("Processing MoveRelativeAutoReply(-10,-10,0,0) ..."));
	m_ListData.SetHorizontalExtent(TextSize.cx);
}
}

void CWp2DemoDlg::OnButtonexecute() 
{
	// TODO: Add your control notification handler code here
	DWORD		dwSuccess;
	char				Data0[256];
	char				acCommand[256];
	pExecuteCommand		Wp2CommExecuteCommand;
	UpdateData(TRUE);
	strcpy(acCommand,m_EditCommand);
	Wp2CommExecuteCommand=(pExecuteCommand)GetProcAddress(hWp2CommDll,"ExecuteCommand");
	dwSuccess=(*Wp2CommExecuteCommand)(acCommand,m_EditLines,Data0);
	if (dwSuccess)
	{
		sprintf(Data0,"Error %d executing command %s",dwSuccess,acCommand);
		AfxMessageBox(Data0);
	}
	else
	{
		m_ListData.AddString(m_EditCommand);
		m_ListData.AddString(Data0);
		m_ListData.SetTopIndex(m_ListData.GetCount()-8);
	}
}

void CWp2DemoDlg::OnSelchangeComboController() 
{
	// TODO: Add your control notification handler code here
char	acItem[32];
int		i;
int		nMaxAxes;
if (m_ComboController.GetCurSel()==1)
	{
	dwControllerMode=WP2_CONTROLLER_DELTA;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_SHOW);
	m_EditCommand="version";
	nMaxAxes=4;
	dwAxes=4;
	}
else if (m_ComboController.GetCurSel()==2)
	{
	dwControllerMode=WP2_CONTROLLER_ALPHA;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_HIDE);
	m_EditCommand="1 nversion";
	nMaxAxes=16;
	dwAxes=4;
	}
else if (m_ComboController.GetCurSel()==3)
	{
	dwControllerMode=WP2_CONTROLLER_TAURUS;
	m_ComboAxes.EnableWindow(FALSE);
	m_Test.ShowWindow(SW_HIDE);
	m_EditCommand="1 nversion";
	nMaxAxes=1;
	dwAxes=1;
	}
else if (m_ComboController.GetCurSel()==4)
	{
	dwControllerMode=WP2_CONTROLLER_PEGASUS;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_HIDE);
	m_EditCommand="1 nversion";
	nMaxAxes=16;
	dwAxes=4;
	}
else if (m_ComboController.GetCurSel()==5)
	{
	dwControllerMode=WP2_CONTROLLER_ORION;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_HIDE);
	m_EditCommand="1 nversion";
	nMaxAxes=16;
	dwAxes=4;
	}
else if (m_ComboController.GetCurSel()==6)
	{
	dwControllerMode=WP2_CONTROLLER_CORVUS;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_SHOW);
	m_EditCommand="version";
	nMaxAxes=3;
	dwAxes=3;
	}
else if (m_ComboController.GetCurSel()==7)
	{
	dwControllerMode=WP2_CONTROLLER_POLLUX;
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_HIDE);
	m_EditCommand="1 nversion";
	nMaxAxes=16;
	dwAxes=2;
	}
else
	{
	dwControllerMode=WP2_CONTROLLER_DEFAULT;
	m_ComboAxes.DeleteString(0);
	m_ComboAxes.EnableWindow(TRUE);
	m_Test.ShowWindow(SW_SHOW);
	m_EditCommand="version";
	nMaxAxes=3;
	dwAxes=3;
	}
m_ComboAxes.ResetContent();
for (i=nMaxAxes;i>=1;i--)
	{
	sprintf(acItem,"%d",i);
	m_ComboAxes.AddString(acItem);
	}
m_ComboAxes.SetCurSel(m_ComboAxes.GetCount()-dwAxes);
UpdateData(FALSE);
SetupComboBoxBaudrate(dwControllerMode);
}

void CWp2DemoDlg::SetupComboBoxBaudrate(int nMode)
{
m_ComboBaudrate.ResetContent();
m_ComboBaudrate.AddString("19200");
m_ComboBaudrate.AddString("9600");
m_ComboBaudrate.AddString("4800");
m_ComboBaudrate.AddString("2400");
m_ComboBaudrate.AddString("1200");
switch(nMode)
	{
case(WP2_CONTROLLER_DELTA):
	m_ComboBaudrate.SelectString(-1,"9600");
	m_ComboBaudrate.EnableWindow(FALSE);
	break;
case(WP2_CONTROLLER_CORVUS):
	m_ComboBaudrate.InsertString(0,"57600");
	m_ComboBaudrate.InsertString(0,"115200");
	m_ComboBaudrate.SelectString(-1,"115200");
	m_ComboBaudrate.EnableWindow(TRUE);
	break;
case(WP2_CONTROLLER_POLLUX):
	m_ComboBaudrate.SelectString(-1,"19200");
	m_ComboBaudrate.EnableWindow(FALSE);
	break;
case(WP2_CONTROLLER_ALPHA):
case(WP2_CONTROLLER_TAURUS):
case(WP2_CONTROLLER_PEGASUS):
case(WP2_CONTROLLER_ORION):
case(WP2_CONTROLLER_DEFAULT):
	m_ComboBaudrate.SelectString(-1,"9600");
	m_ComboBaudrate.EnableWindow(TRUE);
	break;
default:
	m_ComboBaudrate.SelectString(-1,"19200");
	m_ComboBaudrate.EnableWindow(TRUE);
	break;
	}
UpdateData(FALSE);
}
